<?
sapp_include_once('common.php');

function form_handler()
{
	$valid = true;
	//check ssl
	$ssl = sapp_get_submit_value('ssl');
	switch ($ssl) {
		case 'true':
			sapp_set_ssl(true);
			break;

		default:
			sapp_set_ssl(false);
			break;
	}

	// check install_prefix
	$install_prefix = sapp_get_submit_value('install_prefix');
	if (in_array($install_prefix, array(".", "/", "./")))
	{
		$ret = (function_exists('sapp_check_install_prefix'))? sapp_check_install_prefix(SITEAPP_PREFIX_ROOT) : false;
		if (false===$ret || false === in_array($ret, array(SITEAPP_DIR_NOT_EXISTS, SITEAPP_DIR_USED_BY_UNKNOWN)))
		{
			sapp_set_wrong('install_prefix', msg('install_prefix__invalid_name'));
			$valid = false;
		}
	}

	switch (sapp_set_install_prefix($install_prefix)) {

		case SITEAPP_DIR_NOT_EXISTS:
			break;

		case SITEAPP_DIR_USED_BY_UNKNOWN:
			sapp_set_wrong('install_prefix', msg('install_prefix__already_exists'));
			$valid = false;
			break;			

		case SITEAPP_DIR_INVALID_NAME:
			sapp_set_wrong('install_prefix', msg('install_prefix__invalid_name'));
			$valid = false;
			break;

		case SITEAPP_DIR_USED_BY_SITEAPP:
			sapp_set_wrong('install_prefix', msg('install_prefix__used_by_sapp'));
			$valid = false;
			break;
	}


	$admin_email = sapp_get_submit_value('admin_email');
	if (!check_email($admin_email)) {
		sapp_set_wrong('admin_email', msg('invalid_value'));
		$valid = false;
	}
	
	sapp_set_param('admin_email', $admin_email);
	
	$admin_name = sapp_get_submit_value('admin_name');
	sapp_set_param('admin_name', $admin_name);
	
	$admin_fullname = sapp_get_submit_value('admin_fullname');
	sapp_set_param('admin_fullname', $admin_fullname);
	
	$admin_fax = sapp_get_submit_value('admin_fax');
	sapp_set_param('admin_fax', $admin_fax);

	
	//check admin password
	$admin_passwd = sapp_get_submit_value('admin_passwd');
	$admin_confirm = sapp_get_submit_value('admin_confirm');
	if ('' == $admin_passwd) {
		if (!sapp_get_param('admin_passwd')) {
			sapp_set_wrong('admin_passwd', msg('password__empty'));
			$valid = false;
		} else {
			$admin_passwd = sapp_get_param('admin_passwd');
		}
	} elseif ($admin_passwd != $admin_confirm) {
		sapp_set_wrong('admin_passwd', msg('password__not_match'));
		sapp_set_wrong('admin_confirm', msg('password__not_match'));
		$valid = false;
	} else {
		sapp_set_param('admin_passwd', $admin_passwd);
	}

	//check db name
	$dbname = sapp_get_submit_value('dbname');
	if (!check_dbName($dbname)) {
		sapp_set_wrong('dbname', msg('invalid_value'));
		$valid = false;
	}

	sapp_set_param('dbname', $dbname);

	if (sapp_is_database_exists($dbname, 'mysql')) {
		sapp_set_wrong('dbname', msg('db__database_already_exists'));
		$valid = false;
	}
	
	//check db user
	$dbuser = sapp_get_submit_value('dbuser');
	if (!check_dbUserName($dbuser)) {
		sapp_set_wrong('dbuser', msg('invalid_value'));
		$valid = false;
	}

	sapp_set_param('dbuser', $dbuser);

	//check db passwd
	$dbpasswd = sapp_get_submit_value('dbpasswd');
	$dbconfirm = sapp_get_submit_value('dbconfirm');
	if ('' == $dbpasswd) {
		if (!sapp_get_param('dbpasswd')) {
			sapp_set_wrong('dbpasswd', msg('password__empty'));
			$valid = false;
		} else {
			$dbpasswd = sapp_get_param('dbpasswd');
		}
	} elseif ($dbpasswd != $dbconfirm) {
		sapp_set_wrong('dbpasswd', msg('password__not_match'));
		sapp_set_wrong('dbconfirm', msg('password__not_match'));
		$valid = false;
	} else {
		sapp_set_param('dbpasswd', $dbpasswd);
	}
	
	if (sapp_is_database_user_exists($dbname, 'mysql', $dbuser, $dbpasswd)) {
		sapp_set_wrong('dbuser', msg('db__database_user_already_exists'));
		$valid = false;
	}
	
	
	if (!$valid) {
		sapp_set_warning(msg('invalid_values'));
		return 1;
	}
		
	if (!sapp_create_database($dbname, 'mysql')) {
		sapp_set_wrong('dbname', msg('db__unable_to_create'));
		return 1;
	}

	if (!sapp_create_database_user($dbname, 'mysql', $dbuser, $dbpasswd)) {
		sapp_set_wrong('dbuser', msg('db__unable_to_create'));
		return 1;
	}

	// set application URL
	sapp_set_param('application_url', sapp_get_param('install_prefix').'/admin');

	return 2;
}
?>
